<component-section>
  <div slot="title">#️ Hashen</div>
  <component-section>
    <div slot="title">Waarom je over hashen leert</div>
    <p class="praktijk">
      Hashverzamelingen zijn de standaardwijze waarop verzamelingen worden geïmplementeerd in de meeste
      programmeertalen, zeker als het om generieke itemtypes gaat. Overal waar je aan de hand van een sleutel één of
      meer waardes wilt kunnen opzoeken, dus de vele plaatsen waar je associatieve rijen gebruikt, zijn hashtabellen de
      gangbaarste oplossing. Hashtabellen worden gebruikt om bijvoorbeeld elk van grote aantallen URL-paden door te
      leiden naar web views (URL routers). Cryptografische hashalgoritmes worden gebruikt om een unieke verhaspeling van
      een wachtwoord te maken, waardoor wachtwoorden uit elkaar gehouden kunnen worden zonder dat ze open en bloot
      bewaard moeten worden.
    </p>
  </component-section>
  <component-section>
    <div slot="title">De dictionary-adt</div>
    <p>
      Een <em class="table">dictionary</em> of <em>associatieve rij</em> is een adt waarin je met iedere unieke
      <em class="term">sleutel</em> (<em class="term">(search) key</em>) telkens één vaste waarde kan ophalen. Deze adt
      kan op allerlei manieren worden geïmplementeerd, waarvan de <em class="term">hashtabel</em> de belangrijkste is.
    </p>
    <p>OpenDSA maakt dit concept concreet in duidelijke Java-broncode.</p>
    <p class="bron">
      <a href="https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/Dictionary.html">6.4. The Dictionary ADT</a>
    </p>
    <component-section>
      <div slot="title">
        <a href="https://ans.app/digital_test/assignments/297648/routing">Generic dictionaries (op Ans)</a>
      </div>
      <component-exercise></component-exercise>
    </component-section>
  </component-section>
  <component-section>
    <div slot="title">Hashen</div>
    <p>
      In de volgende video geeft Kevin Drumm een eenvoudige inleiding in hashen. Hieruit haal je het overzicht over het
      thema hashen.
    </p>
    <p class="bron">Hash Tables and Hash Functions</p>
    <component-video videoid="KyUTuwz_b7Q" title="Hash Tables and Hash Functions"></component-video>
    <p>
      Hashen is dus een manier om een index te berekenen (met een
      <em class="term">hashfunctie</em>) waarop je een stukje data kan vinden dat je zoekt, met een looptijd van
      \((O(1)\) in het gemiddelde geval, als je hashing goed implementeert).
    </p>
    <component-section>
      <div slot="title">
        <a href="https://ans.app/digital_test/assignments/297651/routing">Slechte hashfunctie (op Ans)</a>
      </div>
      <component-exercise></component-exercise>
    </component-section>
    <p>
      Verder legde Kevin Drumm uit wat een hashtabel-datastructuur kan doen om om te gaan met
      <em class="term">collisions</em> (‘botsingen’: een sleutel blijkt niet uniek), onder de noemer
      <em class="term">collision resolution</em>
      (botsingsoplossing). Dat kan met
      <em class="term">open addressing</em> (bijvoorbeeld <em class="term">linear</em> of
      <em class="term">quadratic probing</em>) of <em class="term">closed addressing</em>/<em class="term"
        >separate chaining</em
      >.
    </p>
    <component-section>
      <div slot="title">
        <a href="https://ans.app/digital_test/assignments/297656/routing"
          >Belangrijkste eigenschappen hashfunctie (op Ans)</a
        >
      </div>
      <component-exercise></component-exercise>
    </component-section>
    <p>OpenDSA legt hashing compleet uit. Hieruit haal je diepgaande kennis.</p>
    <p class="bron">
      <a href="https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/HashIntro.html">10.1. Introduction</a>
    </p>
    <p class="bron">
      <a href="https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/HashFunc.html">10.2. Hash Function Principles</a>
    </p>
    <p class="bron">
      <a href="https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/HashFuncExamp.html">10.3. Sample Hash Functions</a>
    </p>
    <p>
      Om het ‘makkelijker te maken’ gebruiken informatici verwarrende synoniemen voor types collision resolution:
      <em class="term">closed hashing</em> voor <em>open addressing</em> en <em class="term">open hashing</em> is voor
      <em>separate chaining</em>.
    </p>
    <p class="bron">
      <a href="https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/OpenHash.html">10.4. Open Hashing</a>
    </p>
    <p class="bron">
      <a href="https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/BucketHash.html">10.5. Bucket Hashing</a>
    </p>
    <p class="bron">
      <a href="https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/HashCSimple.html">10.6. Collision Resolution</a>
    </p>
    <p class="bron">
      <a href="https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/HashCImproved.html"
        >10.7. Improved Collision Resolution</a
      >
    </p>
    <p class="bron">
      <a href="https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/HashAnal.html">10.8. Analysis of Closed Hashing</a>
    </p>
    <component-section>
      <div slot="title">
        <a href="https://ans.app/digital_test/assignments/297658/routing">Load factor (op Ans)</a>
      </div>
      <component-exercise></component-exercise>
    </component-section>
    <p class="bron">
      <a href="https://opendsa-server.cs.vt.edu/ODSA/Books/CS3/html/HashDel.html">10.9. Deletion</a>
    </p>
  </component-section>
</component-section>
